package netscape.applet;

import java.applet.AudioClip;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import sun.audio.AudioData;
import sun.audio.AudioDataStream;
import sun.audio.AudioPlayer;
import sun.audio.AudioStream;
import sun.audio.ContinuousAudioDataStream;

public class AppletAudioClip implements AudioClip {
   URL url;
   private AudioData data;
   InputStream stream;

   public AppletAudioClip(URL var1) {
      this.url = var1;
   }

   protected void init() {
      if (this.data == null) {
         InputStream var1 = null;

         try {
            try {
               SecurityManager.enablePrivilege("UniversalConnect");
               URLConnection var4 = this.url.openConnection();
               var4.setAllowUserInteraction(true);
               var1 = var4.getInputStream();
               SecurityManager.revertPrivilege();
               this.data = (new AudioStream(var1)).getData();
            } finally {
               if (var1 != null) {
                  var1.close();
               }

            }

         } catch (IOException var8) {
            this.data = null;
         }
      }
   }

   public AppletAudioClip(byte[] var1) {
      this.data = new AudioData(var1);
   }

   public synchronized void play() {
      this.init();
      this.stop();
      if (this.data != null) {
         this.stream = new AudioDataStream(this.data);
         AudioPlayer.player.start(this.stream);
      }

   }

   public synchronized void loop() {
      this.init();
      this.stop();
      if (this.data != null) {
         this.stream = new ContinuousAudioDataStream(this.data);
         AudioPlayer.player.start(this.stream);
      }

   }

   public synchronized void stop() {
      if (this.stream != null) {
         AudioPlayer.player.stop(this.stream);

         try {
            this.stream.close();
         } catch (IOException var1) {
         }
      }
   }

   public String toString() {
      return this.getClass().toString() + "[" + this.url + "]";
   }
}
