package netscape.applet;

import java.applet.Applet;
import java.util.Vector;
import netscape.debug.ThreadState;
import netscape.security.PrivilegeManager;

public class AppletDebugger {
   static NavigatorHook navHook = null;

   private static void checkDebug() {
      PrivilegeManager.checkPrivilegeEnabled("Debugger");
   }

   public static synchronized NavigatorHook setNavigatorHook(NavigatorHook var0) {
      checkDebug();
      NavigatorHook var1 = navHook;
      navHook = var0;
      return var1;
   }

   public static NavigatorHook getNavigatorHook() {
      checkDebug();
      return navHook;
   }

   static void aboutToInit(Applet var0) {
      if (navHook != null) {
         navHook.aboutToInit((ThreadState)null, var0);
      }

   }

   static DerivedAppletFrame getAppletFrame(Applet var0) {
      MozillaAppletContext var1 = (MozillaAppletContext)var0.getAppletContext();
      DerivedAppletFrame var2 = (DerivedAppletFrame)var1.getAppletFrame(var0);
      return var2;
   }

   public static synchronized AppletHook setAppletHook(Applet var0, AppletHook var1) {
      checkDebug();
      DerivedAppletFrame var2 = getAppletFrame(var0);
      AppletHook var3 = var2.hook;
      var2.hook = var1;
      return var3;
   }

   public static AppletHook getAppletHook(Applet var0) {
      checkDebug();
      DerivedAppletFrame var1 = getAppletFrame(var0);
      return var1.hook;
   }

   public static Applet[] getAppletArray() {
      checkDebug();
      return MozillaAppletContext.getAppletArray();
   }

   public static Thread getAppletThread(Applet var0) {
      checkDebug();
      DerivedAppletFrame var1 = getAppletFrame(var0);
      return var1.getThread();
   }

   public static Vector getAppletWindows(Applet var0) {
      checkDebug();
      DerivedAppletFrame var1 = getAppletFrame(var0);
      return var1.topLevelWindows;
   }
}
