package netscape.applet;

import java.awt.Frame;
import java.net.URL;
import netscape.application.Application;
import netscape.application.Color;
import netscape.application.FoundationPanel;
import netscape.application.Rect;
import netscape.application.RootView;
import netscape.util.Enumeration;

public class EmbeddedBeanTracker {
   EmbeddedObject eop;

   EmbeddedBeanTracker(EmbeddedObject var1) {
      this.eop = var1;
   }

   public String className() {
      return this.eop.className;
   }

   public URL documentURL() {
      return this.eop.documentURL();
   }

   public URL codebaseURL() {
      return this.eop.codebaseURL();
   }

   public String attribute(String var1) {
      return (String)this.eop.attributes().get(var1.toLowerCase());
   }

   public String parameter(String var1) {
      return (String)this.eop.parameters().get(var1.toLowerCase());
   }

   public Enumeration parameterKeys() {
      return this.eop.parameters().keys();
   }

   public Enumeration parameterValues() {
      return this.eop.parameters().elements();
   }

   public Application application() {
      return this.eop.task.application();
   }

   public Rect bounds() {
      return new Rect(0, 0, this.eop.width, this.eop.height);
   }

   public void setActualObject(Object var1) {
      this.eop.actualObject = var1;
   }

   public Object getActualObject() {
      return this.eop.actualObject;
   }

   public Frame frame() {
      return this.eop.frame;
   }

   public synchronized RootView rootView() {
      if (this.eop.frame == null) {
         return null;
      } else if (this.eop.panel != null) {
         return this.eop.panel.rootView();
      } else {
         this.eop.panel = new FoundationPanel();
         this.eop.panel.rootView().setColor(Color.lightGray);
         this.eop.panel.resize(this.eop.width, this.eop.height);
         this.eop.frame.add(this.eop.panel);
         this.eop.frame.validate();
         return this.eop.panel.rootView();
      }
   }

   public EmbeddedBeanOwner systemDefaultBeanOwner() {
      return EmbeddedObject.defaultBeanOwner;
   }

   public EmbeddedBeanOwner programDefaultBeanOwner() {
      return this.eop.taskOwner.beanOwner;
   }
}
